/* TAGS: refine pa sym c min */
/* VERIFY_OPTS: -o nofail:malloc --lamp pointers --symbolic */
/* REFINE_OPTS: -o nofail:malloc --refinement pointers */

#include <assert.h>
#include <stdint.h>
#include <stdlib.h>

void fragment( uint8_t * ptr, uint8_t out[ 8 ] )
{
    for ( int i = 0; i < 8; ++i )
        out[ i ]  = ( ( uint8_t * ) ( & ptr ) )[ i ];
}

uintptr_t build( uint8_t fragments[ 8 ] )
{
    uint8_t *out;
    for ( int i = 0; i < 8; ++i )
        ( ( uint8_t * ) ( &out ) )[ i ] = fragments[ i ];
    return ( uintptr_t )out;
}

int main()
{
    uint8_t *a = ( uint8_t * )malloc( 1 );
    uint8_t *b = ( uint8_t * )malloc( 1 );

    uintptr_t ai = ( uintptr_t ) a;
    uintptr_t bi = ( uintptr_t ) b;
    if ( ai < bi )
    {
        free( a ); free( b ); return 0;
    }

    uint8_t a_frag[ 8 ];
    uint8_t b_frag[ 8 ];
    fragment( a, a_frag );
    fragment( b, b_frag );
    assert( !( build( a_frag ) < build( b_frag ) ) );

    free( a ); free( b ); return 0;
}
