/* TAGS: refine pa sym c min */
/* VERIFY_OPTS: -o nofail:malloc --lamp pointers --symbolic */
/* REFINE_OPTS: -o nofail:malloc --refinement pointers */

#include <assert.h>
#include <stdint.h>
#include <stdlib.h>

void fragment( uint8_t * ptr, uint8_t out[ 8 ] )
{
    for ( int i = 0; i < 8; ++i )
        out[ i ]  = ( ( uint8_t * ) ( & ptr ) )[ i ];
}

uintptr_t build( uint8_t fragments[ 8 ] )
{
    uint8_t *out;
    for ( int i = 0; i < 8; ++i )
        ( ( uint8_t * ) ( &out ) )[ i ] = fragments[ i ];
    return ( uintptr_t ) out;
}

int main()
{
    uint8_t *a = ( uint8_t * )malloc( 1 );
    uint8_t *b = ( uint8_t * )malloc( 1 );
    uint8_t *c = ( uint8_t * )malloc( 1 );
    uint8_t *d = ( uint8_t * )malloc( 1 );

    uintptr_t ai = ( uintptr_t ) a;
    uintptr_t bi = ( uintptr_t ) b;
    uintptr_t ci = ( uintptr_t ) c;
    uintptr_t di = ( uintptr_t ) d;
    if ( !( ai < ci && ci < bi && bi < di ) )
    {
        free( a ); free( b ); free( c ); free( d ); return 0;
    }

    uint8_t a_frag[ 8 ];
    uint8_t b_frag[ 8 ];
    fragment( a, a_frag );
    fragment( b, b_frag );
    uint8_t *a_ = ( uint8_t * ) build( a_frag );
    uint8_t *b_ = ( uint8_t * ) build( b_frag );

    assert( !( a_ < c && c < b_ && b_ < d ) ); /* ERROR */

    free( a ); free( b ); free( c ); free( d ); return 0;
}
