/* TAGS: refine pa sym c min */
/* VERIFY_OPTS: -o nofail:malloc --lamp pointers --symbolic -o abort:ptrcmp */
/* REFINE_OPTS: -o nofail:malloc --refinement pointers */

#include <assert.h>
#include <stdlib.h>
#include <stdint.h>

void pointer_xor_swap(char **x, char **y)
{
    uintptr_t a = (uintptr_t)*x;
    uintptr_t b = (uintptr_t)*y;

    a = a ^ b;
    b = a ^ b;
    a = a ^ b;

    *x = (char*)a;
    *y = (char*)b;
}

int main () {
    char * x = (char *)( malloc(1) );
    char * y = (char *)( malloc(1) );

    char * u = x;
    char * v = y;

    pointer_xor_swap( &u, &v );
    assert( x == v );
    assert( y == u );

    free( x );
    free( y );
}
